#pragma once
#include "../matrix4x4.h"
#include "../vector3.h"

class GeomTree;

class Geom {
public:
  Geom(GeomTree*);
  void SetPosition(vector3d pos);
  void SetOrientation(const matrix4x4d& rot);
  const matrix4x4d& GetInvTransform(void) { return m_invOrient; }
  void Enable(void) { m_active = true; }
  void Disable(void) {m_active = false; }
  bool IsEnabled(void) { return m_active; }
  GeomTree* GetGeomTree(void) { return m_geomtree; }
private:
  matrix4x4d m_orient, m_invOrient;
  bool m_active;
  GeomTree* m_geomtree;
};

